"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.useClassNameMapper = useClassNameMapper;
exports.default = exports.ClassNameContext = exports.ClassNameConsumer = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

function buildClassNameMapper(globalClassNameMap, localClassNameMap) {
  return _bind.default.bind((0, _extends2.default)({}, globalClassNameMap, {}, localClassNameMap));
}

var ClassNameContext = _react.default.createContext({
  createClassNameMapper: function createClassNameMapper(localClassNameMap) {
    return buildClassNameMapper({}, localClassNameMap);
  }
});

exports.ClassNameContext = ClassNameContext;
var Consumer = ClassNameContext.Consumer,
    Provider = ClassNameContext.Provider;
exports.ClassNameConsumer = Consumer;

function ClassNameProvider(_ref) {
  var classNameMap = _ref.classNameMap,
      children = _ref.children;
  var globalClassNameMap = (0, _react.useMemo)(function () {
    return (0, _extends2.default)({}, classNameMap);
  }, [classNameMap]);

  var createClassNameMapper = function createClassNameMapper(localClassNameMap) {
    return buildClassNameMapper(globalClassNameMap, localClassNameMap);
  };

  return _react.default.createElement(Provider, {
    value: {
      createClassNameMapper: createClassNameMapper
    }
  }, children);
}

function useClassNameMapper(localClassNameMap) {
  var _useContext = (0, _react.useContext)(ClassNameContext),
      createClassNameMapper = _useContext.createClassNameMapper;

  return createClassNameMapper(localClassNameMap);
}

var _default = ClassNameProvider;
exports.default = _default;